#ifndef ARRAY2D_H
#define ARRAY2D_H

#include <kstddef.h>

template<class T> 
class Array2d {
 private:
    unsigned int nx;
    unsigned int ny;

 public:

    T** array_data;

    Array2d (unsigned int x, unsigned int y)
	{
	    nx = x;
	    ny = y;
	    array_data = new T*[nx];
	    
	    for (unsigned int i = 0; i < nx; i++)
		array_data[i] = new T[ny];
	}


    ~Array2d ()
	{
	    for (int i = 0; i < nx; i++)
		delete array_data[i];
	    delete array_data;
	}
    
    T** getArray (void) const
	{ return array_data; }

    T* getColumn (unsigned int x) const
	{ return array_data[x]; }

    T getPoint (unsigned int x, unsigned int y) const
	{ return (array_data[x][y]); }

    unsigned int sizeofPixel (void) const 
	{  return sizeof(T); }

    unsigned int sizeofColumn (void) const
	{ return (sizeof(T) * ny); }

    unsigned int sizeofArray (void) const
	{ return (sizeof(T) * nx * ny); }
};


#endif
